package com.isoftstone.interview.traffic3;

public enum Lamp {
	/**
	 * 每个Lamp元素代表一个方向上的灯，总共有12个方向，所以总共有12个Lamp元素。
	 * 有如下一些方向上的灯，每两个形成一组，一组灯同时变绿或变红，所以， 程序代码只需要每组灯中的一个灯即可
	 * N2S S2N W2E E2W
	 * 
	 * N2E S2W W2N E2S
	 * 
	 * W2S E2N N2W S2E
	 */
	/*每个枚举元素各表示一个方向的控制灯*/
	S2N("N2S","S2W",false), S2W("N2E","E2W",false), E2W("W2E","W2N",false), W2N("E2S","S2N",false), 
	/*下面元素表示与上面的元素的相反方向的灯，它们的“相反方向灯”和“下一个灯”应忽略不计！*/
	N2S(null,null,false), N2E(null,null,false), W2E(null,null,false), E2S(null,null,false),
	/*由南向东和由西向北等右拐弯的灯不受红绿灯的控制，所以，可以假想它们总是绿灯*/
	S2E(null,null,true),E2N(null,null,true),N2W(null,null,true),W2S(null,null,true);
	

	private Lamp(String opposite, String next, boolean lighted) {
		this.opposite = opposite;
		this.next = next;
		this.lighted = lighted;
	}

	private String opposite;
	private String next;
	private boolean lighted;

	public boolean isLight() {
		return lighted;
	}

	// 某个灯变绿时，它对应方向的灯也要变绿
	public void light() {
		lighted = true;
		if (opposite != null)
			Lamp.valueOf(opposite).light();
		System.out.println(name() + "lamp is green 下面应该有6个方向能看到汽车穿过");
	}

	/***
	 * 当前灯变红，下一个灯变绿
	 * @return 返回下一个变绿的灯
	 */
	public Lamp blackOut() {
		// 当前灯变红
		lighted = false;
		// 对应方向的灯变绿
		if (opposite != null)
			Lamp.valueOf(opposite).blackOut();
		// 使下一个灯变绿
		Lamp nLmap = Lamp.valueOf(next);
//		Lamp nLmap = null;
		if (next != null) {
//			nLmap=Lamp.valueOf(next);
			System.out.println("绿灯从" + name() + "--------->切换到" + nLmap.name());
			nLmap.light();
		}
		//返回下一个要变绿的灯
		return nLmap;
	}
}
