package com.isoftstone.interview.traffic3;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;
/**
 * 每个Road对象代表一条路线，总共有12条路线，即系统中总共要产生12个Road实例对象。
 * 每条路线上随机增加新的车辆，增加到一个集合中保存。
 * 每条路线每隔一秒都会检查控制本路线的灯是否为绿，是则将本次路线保存车的集合中的第一辆车移除，即表示车穿过了路口。
 * @author Administrator
 *
 */
public class Road {
	private List<String> vehicles = new ArrayList<String>();
	private String name=null;
	public Road(String name) {
		this.name=name;
		//模拟车辆不断随机上路的过程 池
		ExecutorService pool=Executors.newSingleThreadExecutor();
		//把一个任务交给这个池了
		pool.execute(new Runnable(){
			public void run(){
				for(int i=1;i<1000;i++){
					try {
						Thread.sleep((new Random().nextInt(10)+1)*1000);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}//访问外部成员变量
					vehicles.add(Road.this.name+"_"+i);	
				}
			}
		});
		//每隔一秒检查对应的灯是否为绿，是则放行一辆车  //调度池
		ScheduledExecutorService timer=Executors.newScheduledThreadPool(1);
		//定时器
		timer.scheduleAtFixedRate(
				new Runnable(){
					public void run(){
						if(vehicles.size()>0){
							//路的名称就是灯
							boolean lighted=Lamp.valueOf(Road.this.name).isLight();
							//绿灯时放行
							if(lighted){
								System.out.println(vehicles.remove(0)+"is traversing！");
							}
						}
					}
				}, 
				1, //过多少秒后干这件事
				1, //干完以后再过多少秒接着干
				TimeUnit.SECONDS);//单位
	}
}
